unit frmNidaqw;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, TAGraph, TASeries, Forms, Controls, Graphics,
  Dialogs, StdCtrls, nidaqmx, NIDAQmxCAPI_TLB;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Chart1: TChart;
    Label1: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;
  TaskHandle: LongInt;
  DAQData: array of Double;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var
  DAQmxError: integer;
  ChannelCount: integer;
  SampsPerChannel: integer=1000;
  RefreshRate: Integer= 1000;
  SamplesCount: integer;
  SampsPerChanRead: LongInt;
  i,j,k: integer;
  LineSeries: array of TLineSeries;
begin
   DAQmxError:= DAQmxCreateTask ('',@TaskHandle);
   if DAQmxError <> 0 then begin Label1.Caption := 'Error №' + IntToStr (DAQmxError); exit; end else Label1.Caption:= 'No error';
   DAQmxError:= DAQmxCreateAIVoltageChan (TaskHandle, 'Dev1/ai0:1','',DAQmx_Val_Cfg_Default, -10,10,DAQmx_Val_VoltageUnits1_Volts,'');
   if DAQmxError <> 0 then begin Label1.Caption := 'Error №' + IntToStr (DAQmxError); exit; end else Label1.Caption:= 'No error';
   DAQmxError:=DAQmxCfgSampClkTiming(taskHandle, 'OnboardClock', RefreshRate, DAQmx_Val_Rising, DAQmx_Val_AcquisitionType_FiniteSamps, SampsPerChannel);
   if DAQmxError <> 0 then begin Label1.Caption := 'Error №' + IntToStr (DAQmxError); exit; end else Label1.Caption:= 'No error';
   DAQmxError:= DAQmxGetTaskNumChans(taskHandle, @ChannelCount);
   if DAQmxError <> 0 then begin Label1.Caption := 'Error №' + IntToStr (DAQmxError); exit; end else Label1.Caption:= 'No error';
   SamplesCount:= SampsPerChannel * ChannelCount;
   SetLength(DAQData,SamplesCount);
   DAQmxError:=DAQmxReadAnalogF64(taskHandle, SampsPerChannel, 10, {DAQmx_Val_GroupByScanNumber}DAQmx_Val_GroupByChannel, @DAQData[0], SamplesCount, @SampsPerChanRead, nil);
   if DAQmxError <> 0 then begin Label1.Caption := 'Error №' + IntToStr (DAQmxError); exit; end else Label1.Caption:= 'No error';

   //Display results
   SetLength(LineSeries,ChannelCount);
   for i:= 0 to ChannelCount- 1 do
   begin
     LineSeries[i]:=TLineSeries.Create (Chart1);
     Chart1.AddSeries (LineSeries[i]);
     k:=0;
     for j:=(i*SampsPerChanRead) to ((i+1)*SampsPerChanRead-1) do
     begin
        LineSeries[i].AddXY(k/RefreshRate,DAQData[j]+(i*30));
        inc(k);
     end;
   end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  label1.Caption :='';
end;

end.

